Index: trunk/SophyaPI/PI/lut.cc
===================================================================
--- trunk/SophyaPI/PI/lut.cc	(revision 203)
+++ trunk/SophyaPI/PI/lut.cc	(revision 204)
@@ -14,5 +14,5 @@
 /* --Methode-- */
 
-LUT::LUT(float min, float max, unsigned short ncol, int typ, int ntable) 
+LUT::LUT(double min, double max, unsigned short ncol, int typ, int ntable) 
 {
 int nlev;
@@ -21,5 +21,5 @@
 nlev = ncol-2;
 if (nlev < 1)  nlev = 1;
-bornes = new float[nlev+1];
+bornes = new double[nlev+1];
 
 if (bornes == NULL)  return;
@@ -40,5 +40,5 @@
 
 /* --Methode-- */
-void LUT::SetLut(float min, float max, int typ)
+void LUT::SetLut(double min, double max, int typ)
 {
 
@@ -49,17 +49,17 @@
   {
   int i;
-  float dx;
+  double dx;
   double dlx;
   switch (typ)
     {
     case kLutType_Lin :
-      dx = (max-min)/(float)nLevel;
+      dx = (max-min)/(double)nLevel;
       for(i=0; i<nLevel; i++)
-        bornes[i] = min+(float)i*dx;
+        bornes[i] = min+(double)i*dx;
       break;
     case kLutType_Log :
-      dlx = log(max-min) / (float)nLevel;
+      dlx = log(max-min) / (double)nLevel;
       for(i=0; i<nLevel; i++)
-        bornes[i] = min+(float)exp((double)i*dlx);
+        bornes[i] = min+(double)exp((double)i*dlx);
       break;
     default:
@@ -87,5 +87,5 @@
 
 /* --Methode-- */
-unsigned short LUT::Apply(float x)
+unsigned short LUT::Apply(double x)
 {
 int i;
@@ -102,5 +102,5 @@
 table = new unsigned short [nt-2];
 tablebinwidth = (Max()-Min())/(nt-2);
-float x = Min()+0.5*tablebinwidth;
+double x = Min()+0.5*tablebinwidth;
 for(int i=0; i<nt-2; i++)  { table[i] = Apply(x); x += tablebinwidth; }
 }
Index: trunk/SophyaPI/PI/lut.h
===================================================================
--- trunk/SophyaPI/PI/lut.h	(revision 203)
+++ trunk/SophyaPI/PI/lut.h	(revision 204)
@@ -19,10 +19,10 @@
 public:
   
-  LUT(float min, float max, unsigned short ncol=16, int typ=kLutType_Lin, int ntable=-1);
+  LUT(double min, double max, unsigned short ncol=16, int typ=kLutType_Lin, int ntable=-1);
   ~LUT();
-  void SetLut(float min, float max, int typ=0);
+  void SetLut(double min, double max, int typ=0);
   void Print();
-  unsigned short Apply(float x);
-  inline unsigned short ApplyFast(float x)
+  unsigned short Apply(double x);
+  inline unsigned short ApplyFast(double x)
     { 
     if (x < Min())  return(0);
@@ -32,6 +32,6 @@
     } 
 
-  inline float Min() { return(bornes[0]); };
-  inline float Max() { return(bornes[nLevel]); };
+  inline double Min() { return(bornes[0]); };
+  inline double Max() { return(bornes[nLevel]); };
   inline int Type() { return(type); };
   inline int NCol() { return(nLevel+2); };
@@ -42,7 +42,7 @@
   int type;
   int nLevel;
-  float * bornes;
+  double * bornes;
   unsigned short * table;
-  float tablebinwidth;
+  double tablebinwidth;
 
 };
Index: trunk/SophyaPI/PI/parradapter.cc
===================================================================
--- trunk/SophyaPI/PI/parradapter.cc	(revision 203)
+++ trunk/SophyaPI/PI/parradapter.cc	(revision 204)
@@ -22,5 +22,5 @@
 
 /* --Methode-- */
-void P1DArrayAdapter::DefineXCoordinate(float x0, float dx)
+void P1DArrayAdapter::DefineXCoordinate(double x0, double dx)
 {
 mOx = x0;  mDx = dx;
@@ -28,5 +28,5 @@
 
 /* --Methode-- */
-float P1DArrayAdapter::X(int i)
+double P1DArrayAdapter::X(int i)
 {
 return(mOx+mDx*i);
@@ -60,5 +60,5 @@
 
 /* --Methode-- */
-void P2DArrayAdapter::DefineXYCoordinates(float x0, float y0, float dx, float dy)
+void P2DArrayAdapter::DefineXYCoordinates(double x0, double y0, double dx, double dy)
 {
 mOx = x0;   mOy = y0;
@@ -67,5 +67,5 @@
 
 /* --Methode-- */
-void P2DArrayAdapter::XYfromxy(int ix, int iy, float& x, float& y)
+void P2DArrayAdapter::XYfromxy(int ix, int iy, double& x, double& y)
 {
 x = mOx+ix*mDx;
@@ -74,5 +74,5 @@
 
 /* --Methode-- */
-int P2DArrayAdapter::CheckDyn(float& min, float& max, float& moy, float& sig, int& nbnul, int& nbsat, int vit)
+int P2DArrayAdapter::CheckDyn(double& min, double& max, double& moy, double& sig, int& nbnul, int& nbsat, int vit)
 {
 // TIMEF ; 
@@ -85,7 +85,7 @@
 
 if (min >= max) { min = -9.e19; max = 9.e19; }
-float minpix = max;
-float maxpix = min; 
-float pixv;
+double minpix = max;
+double maxpix = min; 
+double pixv;
 // printf("DEBUG_CHECKDYN-IN %d - %g %g ", vit, min, max);
 
@@ -130,5 +130,5 @@
 
 /* --Methode-- */
-void P2DArrayAdapter::ComputeLut_PicHisto(float& min, float& max, int nbsig, float fracmax)
+void P2DArrayAdapter::ComputeLut_PicHisto(double& min, double& max, int nbsig, double fracmax)
 {
 // TIMEF ; 
@@ -143,17 +143,20 @@
 
 //  Variable decrivant l'histogramme 
-float minhis, maxhis, binwidth;
+double minhis, maxhis, binwidth;
 int under,over,tothis;
 int *phis;
 int *q;
 
-float MINDYNAMIC = 1.e-5;          /* Gamme dynamique minimale (MaxAff-MinAff)*/
-float FRACPIC =	0.6065;            /*  Valeur de exp(-0.5)   */
-
-
-int nbnul, nbsat, nok;
-float moy, sig;
-if ( min >= (max-MINDYNAMIC) ) nok = CheckDyn(min, max, moy, sig, nbnul, nbsat);
-if (nok < 1) { min=0.; max = 1.; return; }
+double MINDYNAMIC = 1.e-8;          /* Gamme dynamique minimale (MaxAff-MinAff)*/
+double FRACPIC = 0.6065;            /*  Valeur de exp(-0.5)   */
+
+
+
+if ( min >= (max-MINDYNAMIC) ) { 
+  int nbnul, nbsat, nok;
+  double moy, sig; 
+  nok = CheckDyn(min, max, moy, sig, nbnul, nbsat, vitesse);
+  if (nok < 1) { min=0.; max = 1.;  return; }
+  }
 if ( min >= (max-MINDYNAMIC) )  max = min+MINDYNAMIC;
 minhis = min;
@@ -164,4 +167,5 @@
   maxhis = nbin*binwidth + minhis;
   }
+// printf("DEBUG nbin minhis maxhis binwidth = %d %g %g %g \n", nbin, minhis, maxhis, binwidth);
 
 /* allocation dynamique de memoire et mise a zero de l'histogramme */
@@ -202,5 +206,5 @@
 
 /*   On va chercher le sigma du fond  SigmaLeft, SigmaRight */
-int hmin = (int) ( (float)(hmax) * FRACPIC ) ;
+int hmin = (int) ( (double)(hmax) * FRACPIC ) ;
 
 int sigr = 0;
@@ -215,7 +219,7 @@
 if (nbsig < 0)  {  /*   On considere le cas ou NbSigmas est negatif   */
   if ( (bin = binmax+nbsig*sigl) < 0 )  bin = 0;
-  min = minhis + (float)bin*binwidth;
+  min = minhis + (double)bin*binwidth;
   if ( (bin = binmax-nbsig*sigr) >= nbin ) bin = nbin-1;
-  max = minhis + (float)bin*binwidth;
+  max = minhis + (double)bin*binwidth;
   if (max < (min+MINDYNAMIC))  max = min+MINDYNAMIC;
   delete[] phis;  return; 
@@ -235,5 +239,5 @@
 int nbpix = 0;
 for( q = phis+bin ; q < phis+nbin ; q++)  nbpix += (*q);
-nbpix = (int_4)((float)nbpix * fracmax);
+nbpix = (int_4)((double)nbpix * fracmax);
 int nbpix2 = 0; q = phis+bin; 
 int k = bin;
@@ -241,5 +245,5 @@
   { nbpix2 += (*q); k++; q++; }
 
-max = minhis + (float)k*binwidth;
+max = minhis + (double)k*binwidth;
 delete[] phis;
 if (max < (min+MINDYNAMIC))  max = min+MINDYNAMIC;
@@ -258,5 +262,5 @@
 int npx, npy, nppx, nppy, nszp, oszp;
 int i,j,k,l;
-float vpx;
+double vpx;
 
 
@@ -310,5 +314,5 @@
     }
   else if (zm < -1) {       // Compression 
-    float fv = (float)(zmm*zmm); 
+    double fv = (double)(zmm*zmm); 
     for(j=ofy; j<ofy+npy; j+=zmm)
       for(i=ofx; i<ofx+npx; i+=zmm) {
@@ -341,5 +345,5 @@
     }
   else if (zm < -1) {       // Compression 
-    float fv = (float)(zmm*zmm); 
+    double fv = (double)(zmm*zmm); 
     for(j=ofy; j<ofy+npy; j+=zmm)
       for(i=ofx; i<ofx+npx; i+=zmm) {
Index: trunk/SophyaPI/PI/parradapter.h
===================================================================
--- trunk/SophyaPI/PI/parradapter.h	(revision 203)
+++ trunk/SophyaPI/PI/parradapter.h	(revision 204)
@@ -16,12 +16,12 @@
   virtual         ~P1DArrayAdapter();
  
-  virtual float   Value(int i) = 0;
+  virtual double  Value(int i) = 0;
   inline  int     Size() { return (mSize) ; }
-  virtual void    DefineXCoordinate(float x0, float dx);
-  virtual float   X(int i);
+  virtual void    DefineXCoordinate(double x0, double dx);
+  virtual double  X(int i);
      
 protected :
   int mSize;
-  float mOx, mDx;
+  double mOx, mDx;
 };
 
@@ -41,20 +41,20 @@
                                { invx = invX; invy = invY; exy = eXY; }
 
-  virtual void    DefineXYCoordinates(float x0, float y0, float dx, float dy);
+  virtual void    DefineXYCoordinates(double x0, double y0, double dx, double dy);
 // Doit etre defini par les classes derivees
-  virtual float   Value(int ix, int iy) = 0;   
+  virtual double  Value(int ix, int iy) = 0;   
 
-  virtual void    XYfromxy(int ix, int iy, float& x, float& y);
+  virtual void    XYfromxy(int ix, int iy, double& x, double& y);
 
   inline  int     XSize() { return ( eXY ? sY : sX ) ; }
   inline  int     YSize() { return ( eXY ? sX : sY ) ; }
 
-  inline  void    XYCoord(int i, int j, float& x, float& y)
+  inline  void    XYCoord(int i, int j, double& x, double& y)
                          { int ix, iy;  IJ2xy(i, j, ix, iy); 
                            XYfromxy(ix, iy, x, y); }
-  inline  void    Coord(int i, int j, float& x, float& y)
-                       { int ix, iy;  float f; IJ2xy(i, j, ix, iy); 
+  inline  void    Coord(int i, int j, double& x, double& y)
+                       { int ix, iy;  double f; IJ2xy(i, j, ix, iy); 
                        XYfromxy(ix, iy, x, y); if (eXY) {f=x; x=y; y=f; } }
-  inline  float   operator() (int i, int j) 
+  inline  double  operator() (int i, int j) 
                          { int ix, iy;  IJ2xy(i, j, ix, iy); 
                          return Value(ix, iy); }
@@ -65,7 +65,7 @@
 
 //    Calcul Min-Max, Moy-Sig
-  virtual int     CheckDyn(float& min, float& max, float& moy, float& sig, int& nbnul, int& nbsat, int vit=10);
+  virtual int     CheckDyn(double& min, double& max, double& moy, double& sig, int& nbnul, int& nbsat, int vit=10);
 //    Calcul AutoLut
-  virtual void    ComputeLut_PicHisto(float& min, float& max, int nbsig=1, float fracmax=0.95);
+  virtual void    ComputeLut_PicHisto(double& min, double& max, int nbsig=1, double fracmax=0.95);
 
 //    Calcul pixmap avec un LUT
@@ -75,5 +75,5 @@
 protected :
   int sX, sY;
-  float mOx, mDx, mOy, mDy;
+  double mOx, mDx, mOy, mDy;
   int sgnX, sgnY;
   int offX, offY;
@@ -89,5 +89,5 @@
 
   virtual 	  ~P1DAdapter() { if ( (aDel) && (mData != NULL) ) delete[] mData; }
-  virtual float   Value(int i) 
+  virtual double  Value(int i) 
                     {  if ( (i < 0) || (i >= mSize) ) return(0.); 
                     return(mData[i]); }
@@ -106,5 +106,5 @@
 
   virtual 	  ~P2DAdapter() { if ( (aDel) && (mData != NULL) ) delete[] mData; }
-  virtual float   Value(int ix, int iy) 
+  virtual double   Value(int ix, int iy) 
                     {  if ( (ix < 0)  || (iy < 0) || (ix >= sX) || (iy >= sY) ) return(0.); 
                     return(mData[ix+iy*sX]); }
Index: trunk/SophyaPI/PI/pi3ddrw.cc
===================================================================
--- trunk/SophyaPI/PI/pi3ddrw.cc	(revision 203)
+++ trunk/SophyaPI/PI/pi3ddrw.cc	(revision 204)
@@ -38,16 +38,16 @@
 // PIDrawer3D()
 //	Cosntructeur
-// void Set3DView_Obs(float xo, float yo, float zo, float teta, float phi, float psi, -
-//               float dax, float day, float co, float dco=0.2)
+// void Set3DView_Obs(double xo, double yo, double zo, double teta, double phi, double psi, -
+//               double dax, double day, double co, double dco=0.2)
 //	Définition de la vue 3D. Voir "PIGraphic3D::Set3DCS_Obs(...)"
-// void Set3DView(float xc, float yc, float zc, float xo, float yo, float zo, -
-//                float dax, float day, float dco=0.2, float psi=0.)
+// void Set3DView(double xc, double yc, double zc, double xo, double yo, double zo, -
+//                double dax, double day, double dco=0.2, double psi=0.)
 //	Définition de la vue 3D. Voir "PIGraphic3D::Set3DCS(...)"
-// bool Get3DView(float& xc, float& yc, float& zc, float& xo, float& yo, float& zo, -
-//                float& teta, float& phi, float& psi, float& dax, float& day, float& co, float& dco)
+// bool Get3DView(double& xc, double& yc, double& zc, double& xo, double& yo, double& zo, -
+//                double& teta, double& phi, double& psi, double& dax, double& day, double& co, double& dco)
 //	Renvoie la définition de la Vue-3D. Retourne "true " si définie par "Set3DView_Obs()"
-// void Draw3DBoxe(PIGraphic3D* g3, float xx1, float xx2, float yy1, float yy2,  -
-//                 float zz1, float zz2, float xl1, float xl2, -
-//                 float yl1, float yl2, float zl1, float zl2)
+// void Draw3DBoxe(PIGraphic3D* g3, double xx1, double xx2, double yy1, double yy2,  -
+//                 double zz1, double zz2, double xl1, double xl2, -
+//                 double yl1, double yl2, double zl1, double zl2)
 //	Trace une boîte avec les coordonnées matérialisant la vue 3D.
 //--
@@ -73,6 +73,6 @@
 
 /* --Methode-- */
-void PIDrawer3D::Set3DView_Obs(float xo, float yo, float zo, float teta, float phi, float psi, 
-                               float dax, float day, float co, float dco)
+void PIDrawer3D::Set3DView_Obs(double xo, double yo, double zo, double teta, double phi, double psi, 
+                               double dax, double day, double co, double dco)
 {
   tO = teta;  fO = phi;  pO = psi;
@@ -83,6 +83,6 @@
 
 /* --Methode-- */
-void PIDrawer3D::Set3DView(float xc, float yc, float zc, float xo, float yo, float zo, 
-                           float dax, float day, float dco, float psi)
+void PIDrawer3D::Set3DView(double xc, double yc, double zc, double xo, double yo, double zo, 
+                           double dax, double day, double dco, double psi)
 {
   xC = xc;  yC = yc;  zC = zc;
@@ -95,6 +95,6 @@
 
 /* --Methode-- */
-bool PIDrawer3D::Get3DView(float& xc, float& yc, float& zc, float& xo, float& yo, float& zo,
-                           float& teta, float& phi, float& psi, float& dax, float& day, float& co, float& dco)
+bool PIDrawer3D::Get3DView(double& xc, double& yc, double& zc, double& xo, double& yo, double& zo,
+                           double& teta, double& phi, double& psi, double& dax, double& day, double& co, double& dco)
 {
   xo = xO;  yo = yO;  zo = zO;
@@ -136,7 +136,7 @@
 /* --Methode-- */
 void PIDrawer3D::Draw3DBoxe(PIGraphic3D* g3, 
-                            float xx1, float xx2, float yy1, float yy2, 
-                            float zz1, float zz2, float xl1, float xl2, 
-                            float yl1, float yl2, float zl1, float zl2)
+                            double xx1, double xx2, double yy1, double yy2, 
+                            double zz1, double zz2, double xl1, double xl2, 
+                            double yl1, double yl2, double zl1, double zl2)
 {
   if (mLAtt == PI_NotDefLineAtt)    g3->SelLine(PI_ThinLine);
@@ -161,5 +161,5 @@
   x1 = x2 = xx1;   y1 = y2 = yy1;  z1 = z2 = zz1;
   for (k=0; k<NTicks; k++) {
-    x1 = x2 = (xx1+(float)k*(xx2-xx1)/(NTicks-1.));
+    x1 = x2 = (xx1+(double)k*(xx2-xx1)/(NTicks-1.));
     z1 = zz1; z2 = zz1-0.02*(zz2-zz1);
     y1 = y2 = yy1;
@@ -167,5 +167,5 @@
     z2 = zz1-0.05*(zz2-zz1); 
     y2 = yy1-0.075*(yy2-yy1);  
-    sprintf(strg,"%.2g", xl1+(float)k*(xl2-xl1)/(NTicks-1.));
+    sprintf(strg,"%.2g", xl1+(double)k*(xl2-xl1)/(NTicks-1.));
     g3->DrawString3D(x2, y2, z2, strg);
     }
@@ -184,5 +184,5 @@
   x1 = x2 = xx2;   y1 = y2 = yy1;  z1 = z2 = zz1;
   for (k=1; k<NTicks; k++) {   // Attention, par le tick 0 pour Y
-    y1 = y2 = (yy1+(float)k*(yy2-yy1)/(NTicks-1.));
+    y1 = y2 = (yy1+(double)k*(yy2-yy1)/(NTicks-1.));
     z2 = zz1-0.02*(zz2-zz1);
     x1 = x2 = xx2; 
@@ -190,5 +190,5 @@
     z2 = zz1-0.05*(zz2-zz1); 
     x2 = xx2+0.075*(xx2-xx1);  
-    sprintf(strg,"%.2g", yl1+(float)k*(yl2-yl1)/(NTicks-1.));
+    sprintf(strg,"%.2g", yl1+(double)k*(yl2-yl1)/(NTicks-1.));
     g3->DrawString3D(x2, y2, z2, strg);
     }
@@ -207,5 +207,5 @@
   x1 = x2 = xx1;   y1 = y2 = yy1;  z1 = z2 = zz1;
   for (k=0; k<NTicks; k++) {
-    z1 = z2 = (zz1+(float)k*(zz2-zz1)/(NTicks-1.));
+    z1 = z2 = (zz1+(double)k*(zz2-zz1)/(NTicks-1.));
     y2 = yy1-0.015*(yy2-yy1);
     x2 = xx1-0.015*(xx2-xx1);
@@ -213,5 +213,5 @@
     x2 = xx1-0.1*(xx2-xx1);  
     y2 = yy1-0.1*(yy2-yy1);  
-    sprintf(strg,"%.2g", zl1+(float)k*(zl2-zl1)/(NTicks-1.));
+    sprintf(strg,"%.2g", zl1+(double)k*(zl2-zl1)/(NTicks-1.));
     g3->DrawString3D(x2, y2, z2, strg);
     }
@@ -311,6 +311,6 @@
 
 /* --Methode-- */
-void PIDraw3DWdg::Set3DView_Obs(float xo, float yo, float zo, float teta, float phi, float psi, 
-                                float dax, float day, float co, float dco)
+void PIDraw3DWdg::Set3DView_Obs(double xo, double yo, double zo, double teta, double phi, double psi, 
+                                double dax, double day, double co, double dco)
 {
   mGr3d->Set3DCS_Obs(xo, yo, zo, teta, phi, psi, dax, day, co, dco);
@@ -326,6 +326,6 @@
 
 /* --Methode-- */
-void PIDraw3DWdg::Set3DView(float xc, float yc, float zc, float xo, float yo, float zo, 
-                            float dax, float day, float dco, float psi)
+void PIDraw3DWdg::Set3DView(double xc, double yc, double zc, double xo, double yo, double zo, 
+                            double dax, double day, double dco, double psi)
 {
   mGr3d->Set3DCS(xc, yc, zc, xo, yo, zo, dax, day, dco, psi);
@@ -341,6 +341,6 @@
 
 /* --Methode-- */
-bool PIDraw3DWdg::Get3DView(float& xc, float& yc, float& zc, float& xo, float& yo, float& zo, 
-                            float& teta, float& phi, float& psi, float& dax, float& day, float& co, float& dco)
+bool PIDraw3DWdg::Get3DView(double& xc, double& yc, double& zc, double& xo, double& yo, double& zo, 
+                            double& teta, double& phi, double& psi, double& dax, double& day, double& co, double& dco)
 {
   return(mGr3d->Get3DCS(xc, yc, zc, xo, yo, zo, teta, phi, psi, dax, day, co, dco));
@@ -360,5 +360,5 @@
   if (dr3 == NULL)  return;
   dr3->UpdateLimits();
-  float xo, yo, zo, xc, yc, zc, teta, phi, psi, dax, day, co, dco;
+  double xo, yo, zo, xc, yc, zc, teta, phi, psi, dax, day, co, dco;
   bool vobs;
   vobs = dr3->Get3DView(xc, yc, zc, xo, yo, zo, teta, phi, psi, dax, day, co, dco);
@@ -372,7 +372,7 @@
 void PIDraw3DWdg::SetDrawers3DView()
 {
-  float xc, yc, zc, xo, yo, zo;
-  float teta, phi, psi;
-  float dax, day, co, dco;
+  double xc, yc, zc, xo, yo, zo;
+  double teta, phi, psi;
+  double dax, day, co, dco;
   bool vo;
   vo = mGr3d->Get3DCS( xc, yc, zc, xo, yo, zo, teta, phi, psi, dax, day, co, dco);
@@ -398,5 +398,5 @@
 if (!vfixed)  { 
   dr3->UpdateLimits();
-  float xo, yo, zo, xc, yc, zc, teta, phi, psi, dax, day, co, dco;
+  double xo, yo, zo, xc, yc, zc, teta, phi, psi, dax, day, co, dco;
   bool vobs;
   vobs = dr3->Get3DView(xc, yc, zc, xo, yo, zo, teta, phi, psi, dax, day, co, dco);
@@ -405,5 +405,5 @@
   }
 else { 
-  float xc, yc, zc, xo, yo, zo, teta, phi, psi, dax, day, co, dco;
+  double xc, yc, zc, xo, yo, zo, teta, phi, psi, dax, day, co, dco;
   if ( Get3DView(xc, yc, zc, xo, yo, zo, teta, phi, psi, dax, day, co, dco) ) 
       dr3->Set3DView_Obs(xo, yo, zo, teta, phi, psi, dax, day, co, dco);
@@ -468,6 +468,6 @@
 strncpy(pc, (char*)pdata, ll-1);  pc[ll-1] = '\0';
 // printf("PIDraw3DWdg::PasteSelection() / Debug  %s - %d %d -> %g %g \n", pc, 
-//        mPx, mPy, (float)mPx/(float)XSize(), 1.-(float)mPy/(float)YSize());
-mBDrw->ElAddText((float)mPx/(float)XSize(), 1.-(float)mPy/(float)YSize(), pc );
+//        mPx, mPy, (double)mPx/(double)XSize(), 1.-(double)mPy/(double)YSize());
+mBDrw->ElAddText((double)mPx/(double)XSize(), 1.-(double)mPy/(double)YSize(), pc );
 mBDrw->Refresh();
 }
@@ -477,7 +477,7 @@
 {
   mGr3d->SetBaseGraphic(mWGrC, 0, 0, XSize(), YSize());
-  float xo, yo, zo;
-  float teta, phi, psi;
-  float dax, day, co, dco;
+  double xo, yo, zo;
+  double teta, phi, psi;
+  double dax, day, co, dco;
   mGr3d->Get3DCS(cXc, cYc, cZc, xo, yo, zo, teta, phi, psi, dax, day, co, dco);
 //   puts("\n PIDraw3DWdg::But2Press() ");
@@ -525,14 +525,14 @@
 {
   DrawXYZAxes();
-  float teta, phi;
+  double teta, phi;
 
   if (rOfg) { 
-    phi = cPhi + (M_PI*0.25*(float)(x-lPx)/XSize());
-    teta = cTeta - (M_PI*0.25*(float)(y-lPy)/YSize());
+    phi = cPhi + (M_PI*0.25*(double)(x-lPx)/XSize());
+    teta = cTeta - (M_PI*0.25*(double)(y-lPy)/YSize());
     mGr3d->RotateObject(teta, phi, false);
     }
   else {
-    phi = cPhi - (M_PI*0.5*(float)(x-lPx)/XSize());
-    teta = cTeta + (M_PI*0.5*(float)(y-lPy)/YSize());
+    phi = cPhi - (M_PI*0.5*(double)(x-lPx)/XSize());
+    teta = cTeta + (M_PI*0.5*(double)(y-lPy)/YSize());
     mGr3d->RotateObserver(teta, phi, 0., false);
     }
@@ -569,7 +569,7 @@
 void PIDraw3DWdg::But3Press(int x, int y)
 {
-  float xo, yo, zo;
-  float teta, phi, psi;
-  float dax, day, co, dco;
+  double xo, yo, zo;
+  double teta, phi, psi;
+  double dax, day, co, dco;
   mGr3d->Get3DCS(cXc, cYc, cZc, xo, yo, zo, teta, phi, psi, dax, day, co, dco);
   mGr3d->SetBaseGraphic(mWGrC, 0, 0, XSize(), YSize());
@@ -597,10 +597,10 @@
 {
   DrawXYZAxes();
-  float rapx = (float)(lPx-x)/XSize();
+  double rapx = (double)(lPx-x)/XSize();
   if (rapx > 0.) rapx = rapx*2.+1;
   else rapx += 1.;
   if (rapx < 0.3)  rapx = 0.3;
   if (rapx > 3.)  rapx = 3.;
-  float rapy = (float)(y-lPy)/YSize();
+  double rapy = (double)(y-lPy)/YSize();
   if (rapy > 0.) rapy = rapy*2.+1;
   else rapy += 1.;
@@ -649,5 +649,5 @@
 //   mGr3d->DrawCircle(0., 0., daxO*0.30);
   char buff[256];
-  float xc,yc,zc,xo,yo,zo,teta,phi,psi,dax,day,co,dco;
+  double xc,yc,zc,xo,yo,zo,teta,phi,psi,dax,day,co,dco;
   mGr3d->Get3DCS(xc,yc,zc,xo,yo,zo,teta,phi,psi,dax,day,co,dco);
   sprintf(buff, " C: %g %g %g -> O: %g %g %g  (T/P0= %g %g)     ", xc,yc,zc, xo, yo, zo, cTeta, cPhi);
@@ -676,6 +676,6 @@
 y -= YSize()/2;
 
-float fx = (float)x/XSize(); 
-float fy = (float)y/YSize(); 
+double fx = (double)x/XSize(); 
+double fy = (double)y/YSize(); 
 if ( (fx<0.2) && (fx>-0.2) && (fy<0.2) && (fy>-0.2) ) {
   
@@ -694,5 +694,5 @@
   isw++;
   mGr3d->PrintCS();
-  float xc,yc,zc,xo,yo,zo,teta,phi,psi,dax,day,co,dco;
+  double xc,yc,zc,xo,yo,zo,teta,phi,psi,dax,day,co,dco;
   mGr3d->Get3DCS(xc,yc,zc,xo,yo,zo,teta,phi,psi,dax,day,co,dco);
   mGr3d->Set3DCS(xc,yc,zc,xo,yo,zo,dax,day,dco,psi);
Index: trunk/SophyaPI/PI/pi3ddrw.h
===================================================================
--- trunk/SophyaPI/PI/pi3ddrw.h	(revision 203)
+++ trunk/SophyaPI/PI/pi3ddrw.h	(revision 204)
@@ -22,35 +22,35 @@
   virtual		~PIDrawer3D();
 
-  virtual void		Set3DView_Obs(float xo, float yo, float zo, float teta, float phi, float psi, 
-                                      float dax, float day, float co, float dco=0.2);
-  virtual void       	Set3DView(float xc, float yc, float zc, float xo, float yo, float zo, 
-                                  float dax, float day, float dco=0.2, float psi=0.);
-  bool           	Get3DView(float& xc, float& yc, float& zc, float& xo, float& yo, float& zo,
-                                  float& teta, float& phi, float& psi, float& dax, float& day, float& co, float& dco);
+  virtual void		Set3DView_Obs(double xo, double yo, double zo, double teta, double phi, double psi, 
+                                      double dax, double day, double co, double dco=0.2);
+  virtual void       	Set3DView(double xc, double yc, double zc, double xo, double yo, double zo, 
+                                  double dax, double day, double dco=0.2, double psi=0.);
+  bool           	Get3DView(double& xc, double& yc, double& zc, double& xo, double& yo, double& zo,
+                                  double& teta, double& phi, double& psi, double& dax, double& day, double& co, double& dco);
   
   virtual PIGraphicUC*	SetDrwWdg(PIBaseWdgGen* drw, int x0, int y0, int dx, int dy, PIGraphicGen* g);
 
   virtual void       	DrawAxes(PIGraphicUC* g);
-  virtual void       	Draw3DBoxe(PIGraphic3D* g3, float xx1, float xx2, float yy1, float yy2, 
-                                                    float zz1, float zz2, float xl1, float xl2, 
-                                                    float yl1, float yl2, float zl1, float zl2);
+  virtual void       	Draw3DBoxe(PIGraphic3D* g3, double xx1, double xx2, double yy1, double yy2, 
+                                                    double zz1, double zz2, double xl1, double xl2, 
+                                                    double yl1, double yl2, double zl1, double zl2);
 
-  float XMin3() const {return x3Min;}
-  float XMax3() const {return x3Max;}
-  float YMin3() const {return y3Min;}
-  float YMax3() const {return y3Max;}
-  float ZMin3() const {return z3Min;}
-  float ZMax3() const {return z3Max;}
+  double XMin3() const {return x3Min;}
+  double XMax3() const {return x3Max;}
+  double YMin3() const {return y3Min;}
+  double YMax3() const {return y3Max;}
+  double ZMin3() const {return z3Min;}
+  double ZMax3() const {return z3Max;}
 
 protected :
-  float xO, yO, zO;  // Position observateur = camera
-  float xC, yC, zC;  // Position centre du champ
-  float tO,fO,pO;    // Orientation observateur (Teta, Phi, Psi, Angles d Euler)
-  float daxO, dayO;  // Demi-ouverture de la camera suivant les deux axes de projection (xp/zp, yp/zp) 
-  float lCO, dlCO;   // Distance Camera-Centre du champ et profondeur de champ 
+  double xO, yO, zO;  // Position observateur = camera
+  double xC, yC, zC;  // Position centre du champ
+  double tO,fO,pO;    // Orientation observateur (Teta, Phi, Psi, Angles d Euler)
+  double daxO, dayO;  // Demi-ouverture de la camera suivant les deux axes de projection (xp/zp, yp/zp) 
+  double lCO, dlCO;   // Distance Camera-Centre du champ et profondeur de champ 
   bool v3D_obs;      // Si defini par Set3DView_Obs 
-  float x3Min, x3Max;  // Pour delimiter le cube 3D 
-  float y3Min, y3Max;  // Pour delimiter le cube 3D 
-  float z3Min, z3Max;  // Pour delimiter le cube 3D 
+  double x3Min, x3Max;  // Pour delimiter le cube 3D 
+  double y3Min, y3Max;  // Pour delimiter le cube 3D 
+  double z3Min, z3Max;  // Pour delimiter le cube 3D 
 };
 
@@ -68,10 +68,10 @@
 
 
-  virtual void		Set3DView_Obs(float xo, float yo, float zo, float teta, float phi, float psi, 
-                                      float dax, float day, float co, float dco=0.2);
-  virtual void       	Set3DView(float xc, float yc, float zc, float xo, float yo, float zo, 
-                                  float dax, float day, float dco=0.2, float psi=0.);
-  bool           	Get3DView(float& xc, float& yc, float& zc, float& xo, float& yo, float& zo, 
-                                  float& teta, float& phi, float& psi, float& dax, float& day, float& co, float& dco);
+  virtual void		Set3DView_Obs(double xo, double yo, double zo, double teta, double phi, double psi, 
+                                      double dax, double day, double co, double dco=0.2);
+  virtual void       	Set3DView(double xc, double yc, double zc, double xo, double yo, double zo, 
+                                  double dax, double day, double dco=0.2, double psi=0.);
+  bool           	Get3DView(double& xc, double& yc, double& zc, double& xo, double& yo, double& zo, 
+                                  double& teta, double& phi, double& psi, double& dax, double& day, double& co, double& dco);
 
   virtual void          Update3DView();   // Vue 3-D a partir de Drawer No 1
@@ -114,7 +114,7 @@
   int lPx, lPy;         // dernier position pointeur
   PIColors lCol;        // Couleur
-  float cTeta, cPhi, cUlen;    // Pour garder valeurs avant rotation, Unite de longeur
-  float cXc, cYc, cZc;         // Pour garder position du centre de champ 
-  float clCO, cDax, cDay;      // Pour garder les valeurs avant Zoom In/Out
+  double cTeta, cPhi, cUlen;    // Pour garder valeurs avant rotation, Unite de longeur
+  double cXc, cYc, cZc;         // Pour garder position du centre de champ 
+  double clCO, cDax, cDay;      // Pour garder les valeurs avant Zoom In/Out
   bool  rOfg;                  // si Vrai  on fait tourner l'objet et pas la camera
   bool  axfg;                  // si Vrai on trace les axes
